from pathlib import Path
from rougail import Rougail
from rougail.config import get_rougail_config
from rougail.output_doc import RougailOutputDoc


def test_force_optional():
    test_dir = Path(__file__).resolve().parent
    rougailconfig = get_rougail_config(backward_compatibility=False)
    rougailconfig['step.output'] = 'doc'
    rougailconfig['force_optional'] = True
#    rougailconfig['tiramisu_cache'] = 'p.py'
    dirs = [str(test_dir / 'force_optional')]
    rougailconfig['main_structural_directories'] = dirs
    rougailconfig['doc.output_format'] = 'asciidoc'
    rougailconfig['doc.change_default_value'] = True
    rougail = Rougail(rougailconfig)
    config = rougail.run()
    inventory = RougailOutputDoc(config, rougailconfig=rougailconfig)
    doc = inventory.run()[1]
    result_file = test_dir / 'force_optional.adoc'
    if not result_file.is_file():
        with open(str(result_file), 'w') as docfh:
            docfh.write(doc)
    with open(str(result_file)) as docfh:
        result = docfh.read()
    assert doc == result, result_file
